<?php

/**
 * com_resol_comis_objs actions.
 *
 * @package    controlComisiones
 * @subpackage com_resol_comis_objs
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class com_resol_comis_objsActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'COM_RESOL_COMIS_OBJS',
        'COM_RESOL_COMISIONADOS',
        'PR_RESOLUCIONES_V',
        'COM_COMISIONADOS_RESOL_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'COM_RESOL_COMISIONADOS' =>
        array(
            'id_resol_comisionados' => 'COM_RESOL_COMIS_OBJS'
        ),
        'PR_RESOLUCIONES_V' =>
        array(
            'id_resoluciones' => 'COM_RESOL_COMISIONADOS'
        ),
        'COM_COMISIONADOS_RESOL_V' =>
        array(
            'nitocc' => 'COM_RESOL_COMISIONADOS',
            'id_resol_orig-id_resol_comis' => 'PR_RESOLUCIONES_V'
        ),
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'COM_RESOL_COMIS_OBJS' =>
        array(
            'id_resol_comis_objs' => 'id_resol_comis_objs',
            'id_resol_comisionados' => 'id_resol_comisionados',
            'codobj' => 'codobj',
            'valor' => 'valor',
            'viaticos' => 'viaticos',
            'taxis' => 'taxis',
            'tarifa' => 'tarifa',
            'id_obj_gasto' => 'id_obj_gasto',
            'observaciones' => 'observaciones'
        ),
        'COM_RESOL_COMISIONADOS' =>
        array(
            'nitocc' => 'nitocc',
            'id_resoluciones' => 'id_resoluciones',
        ),
        'PR_RESOLUCIONES_V' =>
        array(
            'id_resol_orig' => 'id_resol_orig',
            'resolucion_orig' => 'resolucion_orig',
            'resolucion' => 'resolucion'
        ),
        'COM_COMISIONADOS_RESOL_V' =>
        array(
            'razsoc' => 'razsoc',
            'tipo_comisionado' => 'tipo_comisionado',
            'desreg' => 'desreg',
            'abreviatura' => 'abreviatura',
            //'tipoter_text' => 'tipoter_text',//Incidente #32568,se comenta campo ya que al consultar este campo se queda la consulta - 20221104::LAVILA
            'num_doc' => 'num_doc'
        ),
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'id_resol_comis_objs'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'COM_RESOL_COMIS_OBJS' =>
        array(
            'id_resol_comis_objs,a' => array('!=' => array(-1)),
            'id_resol_comis_objs,b' => array('=' => array('id_resol_comis_objs')),
            'id_resol_comisionados' => array('=' => array('id_resol_comisionados')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    protected $query_qualifier = 'DISTINCT'; //Variable para el sql para eliminar filas repetidas


    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_resol_comis_objs'; //identificador de la tabla
    protected $id_names = array('id_resol_comis_objs'); //llave primaria
    protected $field_names = array('id_resol_comisionados', 'codobj', 'valor', 'viaticos', 'taxis', 'tarifa',
        'id_obj_gasto', 'observaciones'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'COM_RESOL_COMIS_OBJS'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_resol_comis_objs'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {


            //Creamos conexion
            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            /**
             * Se completo registro de comis_OBJ segun resol_modif_obj - 20230922::LAVILA
             */
            $id_obj_gasto = $request['id_obj_gasto'];
            $codobj = $request['codobj'];
            $id_resol_comisionados = $request['id_resol_comisionados'];

            //sentencia sql
            $sql = <<<EOD

select 
resori.id_comision,
resori.vigencia,
resori.id_vigencia,
rescom.nitocc

from pr_resol_comis resori

join pr_resoluciones res
on res.id_resol_orig = resori.id

join com_resol_comisionados rescom
on rescom.id_resoluciones = res.id_resoluciones

left join comisionados_objs obj
on obj.id_comision = resori.id_comision
and obj.vigencia = resori.vigencia

where
rescom.id_resol_comisionados = $id_resol_comisionados
and obj.codobj = '$codobj'
EOD;
            //ejecuta el sql
            $records = CN_TABLE::executeSQL($sql);

            if (count($records) == 0) {
                $logger->info("El objeto ingresado no existe para el comisionado, se crea en 0.");

                //sentencia sql
                $sql = <<<EOD
select 
resori.id_comision,
resori.vigencia,
resori.id_vigencia,
rescom.nitocc

from pr_resol_comis resori

join pr_resoluciones res
on res.id_resol_orig = resori.id

join com_resol_comisionados rescom
on rescom.id_resoluciones = res.id_resoluciones

where
rescom.id_resol_comisionados = $id_resol_comisionados
EOD;
                //ejecuta el sql
                $records = CN_TABLE::executeSQL($sql);

                if (count($records) > 0) {
                    $nitocc = $records[0]['nitocc'];
                    $vigencia = $records[0]['vigencia'];
                    $comision = $records[0]['id_comision'];

                    $sql = <<<EOD
Insert into COMISIONADOS_OBJS (NITOCC,CODOBJ,ID_COMISION,VALOR,ESTADO,VIGENCIA,OBSERVA,
    VIATICOS,TAXIS,TARIFA,ID_OBJ_GASTO,TARIFA_TIQUETE,CANT_DIA_SAL,CANT_DIA_REG,VL_TARIFA_A,VL_TARIFA_B) 
values ('$nitocc','$codobj','$comision','0','1','$vigencia',null,
    '0','0','0','$id_obj_gasto','0','0','0','0','0')
EOD;
                    //ejecuta el sql
                    $this->conn->execute($sql);
                    $this->conn->commit();
                }
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            $request['nitocc'] = $request['num_doc'];
        }

        //accion update
        if ($Action == "UPDATE") {
            /* $request['nitocc'] = $request['num_doc'];

              //Si es obj gasto 06 toma encuenta valores de liqudiar viaticos
              $id_plan_comisiones = $request['id_plan_comisiones'];
              $vigencia = $request['vigencia'];
              $nitocc = $request['nitocc'];
              $codobj = $request['codobj'];
              $valor = $request['valor'];

              //Se toma por id para verificar si aplica viaticos y no por codigo - 20190801
              if (isset($request['id_obj_gasto'])) {

              $id_obj_gasto = $request['id_obj_gasto'];

              //sentencia sql
              $sql = <<<EOD
              SELECT
             *
              FROM objetos_gasto
              where
              id = $id_obj_gasto
              and viatico = 1
              EOD;
              //ejecuta el sql
              $records = CN_TABLE::executeSQL($sql);
              if (count($records) > 0) {
              $request['valor'] = $request['valor'] + $request['viaticos'] + $request['taxis'];
              }
              } else {
              if ($codobj == '06') {
              $request['valor'] = $request['valor'] + $request['viaticos'] + $request['taxis'];
              }
              } */
        }

        //accion remove
        if ($Action == "REMOVE") {
            $request['nitocc'] = $request['num_doc'];
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
        //$request['nitocc'] = $request['num_doc'];
        //$nitocc = $request['nitocc'];
        $codobj = $request['codobj'];
        $id_resol_comisionados = $request['id_resol_comisionados'];
        //$vigencia = $request['vigencia'];

        /*
         *  Generar errores en $errors
         */
        //sentencia sql
        $sql = <<<EOD
SELECT
    *
FROM COM_RESOL_COMIS_OBJS
where
codobj = '$codobj'
and id_resol_comisionados = $id_resol_comisionados
EOD;
        //ejecuta el sql
        $records = CN_TABLE::executeSQL($sql);

        if (count($records) > 0) {
            $errors['mensaje'] = "El objeto ingresado ya existe para el comisionado.";
            $errors['servicio'] = "COM_RESOL_COMIS_OBJS";
            $logger->info("El objeto ingresado ya existe para el comisionado.");
        }

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */


        return $errors;
    }

}
